#ifndef E_STACK_H
#define E_STACK_H

extern e_obj_descriptor e_obj_descriptor_stack;
#define E_IS_STACK(P) (E_OBJ_DESCR(P) == &e_obj_descriptor_stack)
#define E_TYPE_STACK (&e_obj_descriptor_stack)

                  /* Recognised object types */
#define E_STACK_TYPE_CHAR    1
#define E_STACK_TYPE_INT     2
#define E_STACK_TYPE_POINTER 3 
#define E_STACK_TYPE_OBJECT  4

                  /* The initial stack size  */
#define  E_STACK_DEF_SIZE 10

                  /* Object structure to save data on the stack */
typedef union {
  char c;
  int i;
  void *p;
} e_stack_obj;

typedef struct {
  e_obj h;         /* object header                   */  
  e_stack_obj *buf;/* dynamic Buffer of object        */
  int type;        /* type of objects                 */
  int size;        /* Buffer size                     */
  int index;       /* next gree slot in Buffer        */
} e_stack;

e_stack *e_stack_new(e_stack *sp,int type,int size);
void e_stack_free(void *sp);
int e_stack_push(e_stack *sp,void *p);
int e_stack_pop(e_stack *sp,void *p);
void *e_stack_to_string(void *sp,int tab,e_flag mode);
void *e_stack_clone(void *sp,e_flag mode);
int e_stack_equals(void *p1,void *p2);




#define E_STACK_BUF(P) (((e_stack *)P)->buf)
#define E_STACK_TYPE(P) (((e_stack *)P)->type)
#define E_STACK_SIZE(P) (((e_stack *)P)->size)
#define E_STACK_INDEX(P) (((e_stack *)P)->index)

#define E_STACK_IS_EMPTY(P) (((e_stack *)P)->index == 0)

/* To do : swap objects on the stack */
#endif
