#ifndef SYSF_DIR_H
#define SYSF_DIR_H
#include <easy.h>
#include <stdio.h>
#include <sys/stat.h>
#include <unistd.h>
#include <sysf_com.h>

#define DE_INDEX_NAME  (0)
#define DE_INDEX_OWNER (1)
#define DE_INDEX_GROUP (2)
#define DE_INDEX_MODES (3)
#define DE_INDEX_TYPE  (4)
#define DE_INDEX_SIZE  (5)
#define DE_INDEX_CKSUM (6)
#define DE_INDEX_LINK  (7)

#define DE_NAME_NAME  (Dir_Entry_Names[DE_INDEX_NAME])
#define DE_NAME_OWNER (Dir_Entry_Names[DE_INDEX_OWNER])
#define DE_NAME_GROUP (Dir_Entry_Names[DE_INDEX_GROUP])
#define DE_NAME_MODES (Dir_Entry_Names[DE_INDEX_MODES])
#define DE_NAME_TYPE (Dir_Entry_Names[DE_INDEX_TYPE])
#define DE_NAME_SIZE (Dir_Entry_Names[DE_INDEX_SIZE])
#define DE_NAME_CKSUM (Dir_Entry_Names[DE_INDEX_CKSUM])
#define DE_NAME_LINK (Dir_Entry_Names[DE_INDEX_LINK])


#define E_SYSF_DIR_DEF_WORD   "_@$a-zA-Z0-9--./!%&*+<>\\\\^?|~"
#define E_SYSF_DIR_DEF_OP     "#="
#define E_SYSF_DIR_DEF_PUNCT  "'(),:;`[]{}"
#define E_SYSF_DIR_DEF_SPACES " \a\b\t\v\f\r"

#define STATE_DIR_NEW     1
#define STATE_DIR_EQUAL   2
#define STATE_DIR_HOST    3
#define STATE_DIR_ITEM    3

#define HASH_Q2 1048573
#define HASH_Q1 2039

typedef struct {
  char name[E_BUFF_SIZE];
  unsigned int owner;
  unsigned int group;
  unsigned int modes;
  char type[E_WORD_SIZE];
  int size;
  char checksum[E_BUFF_SIZE];
  char link[E_BUFF_SIZE];
} file_pars;

void init_dir_entry_names();
e_aset *dir_read_sys(char *dir_path,e_aset *asp_config);
e_aset *get_file_pars(char *path,char *conf_type);
int dir_make_config_file(e_aset *asp,char *file_name,int echo);
void print_file_props(e_aset *asp, FILE *fpt);
e_aset *dir_read_config(char *file_path);
e_aset *dir_list_diff(e_aset *asp1,e_aset *asp2);
int test_file_properties(e_aset *asp1,e_aset *asp2);
int fill_file_pars(e_aset *asp,file_pars *fp);
int dir_config_sys_differ(e_aset *asp);
int dir_check(e_aset *aspi,int echo);
int dir_diff(e_aset *asp,int echo);
int dir_install(sysfile_info *sip,e_aset *asp,char *sys_file,int echo,int mode);
int remove_dir_entry(sysfile_info *sip,file_pars *fpp,char *sys_file,int echo);
int rename_dir_entry(sysfile_info *sip,file_pars *fpp,char *sys_file,int echo);
int create_dir_entry(sysfile_info *sip,file_pars *fpp,char *sys_file,int echo);
int install_dir_entry(sysfile_info *sip,file_pars *fp_sys,file_pars *fp_conf,
                      char *sys_file,int echo,int mode);
int sysf_check_sum(char *file_name,char *buff,int echo);
unsigned int hash_file(char *file_name);
unsigned int md5_hash(char *file_name,char *buff);
int execute_DL_aux_com(sysfile_info *sip,char *sys_file, char type, 
                       char *action, int echo);
#endif
